#property copyright "Spiggy"
#property link      ""

#define info ",   : Integer, for-good-letters@yandex.ru.   - http://codebase.mql4.com/ru/1356"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Yellow
#property indicator_width1 2

extern int       Length =  14;
extern int       Phase  =  0;

double JMA[];
double MaxAbsDifAver[];
double MaxAbsDif[];
double UpperBound[];
double LowerBound[];
double MA1[];
double DivMA[];
double Add[];

double K0;
double K1;
double K2;
double K3;
double K4; 

int init() {

   JMA_Init();

   IndicatorBuffers(8);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,JMA);
   SetIndexBuffer(1,MaxAbsDifAver);    
   SetIndexBuffer(2,MaxAbsDif);
   SetIndexBuffer(3,UpperBound);   
   SetIndexBuffer(4,LowerBound);   
   SetIndexBuffer(5,MA1);
   SetIndexBuffer(6,DivMA);   
   SetIndexBuffer(7,Add);
   return(0);
}


void JMA_Init(){

   double TK1=(Length-1.0)/2.0;
   K0=Phase/100+1.5;
   
   if(MathLog(MathSqrt(TK1))<-2.0*MathLog(2.0)){//3
      K1=0;
   }
   else{
      K1=MathLog(MathSqrt(TK1))/MathLog(2.0)+2.0;
   }
   
   if(K1>=2.5){
      K2=K1-2.0;
   }
   else{//3
      K2=0.5;
   }
   
   K3=MathSqrt(TK1)*K1/(MathSqrt(TK1)*K1+1.0);
   K4=TK1*0.9/(TK1*0.9 + 2.0); 
}

int start(){

         int ic=IndicatorCounted();
         int limit=Bars-ic-1;
         
            if(ic==0){
               LowerBound[limit]=Close[limit];
               UpperBound[limit]=Close[limit];
               JMA[limit]=Close[limit];
               MA1[limit]=Close[limit];
               DivMA[limit]=0;
               Add[limit]=0;
               JMA[limit]=Close[limit];  
               limit--;          
            }

            for(int i=limit;i>=0;i--){
               double Dif1=Close[i]-UpperBound[i+1];
               double Dif2=Close[i]-LowerBound[i+1];
               MaxAbsDif[i]=MathMax(MathAbs(Dif1),MathAbs(Dif2));
               MaxAbsDifAver[i]=SolveAver(MaxAbsDif,i,10);
               double SortedPertAver=SolveSortedPartAver(MaxAbsDifAver,i);
               double Power=MathMax(MathMin(K1,MathPow(MaxAbsDif[i]/SortedPertAver,K2)),1);                       
               UpperBound[i]=Close[i];
               LowerBound[i]=Close[i];                                               
                  if(Dif1<=0){
                     UpperBound[i]=Close[i]-Dif1*MathPow(K3,MathSqrt(Power));
                  }
                  if(Dif2>=0){
                     LowerBound[i]=Close[i]-Dif2*MathPow(K3,MathSqrt(Power));
                  }
               double k=MathPow(K4,Power);
               double pk2=k*k;
               double m2k=-k*2;
               double kx=m2k+pk2+1.0;
               MA1[i]=(1.0-k)*Close[i]+k*MA1[i+1];
               DivMA[i]=(Close[i]-MA1[i])*(1.0-K4)+K4*DivMA[i+1];
               double fD0=K0*DivMA[i]+MA1[i];
               Add[i]=(fD0-JMA[i+1])*kx+pk2*Add[i+1];
               JMA[i]=JMA[i+1]+Add[i];
            }

   return(0);
  }
//+------------------------------------------------------------------+

double SolveAver(double & aA[],int aS,int aP){
   double sum=0;
   for(int i=aS;i<aS+aP;i++)sum+=aA[i];
   return(sum/aP);
}

double SolveSortedPartAver(double & aA[],double aS){
   double tmp[128];
   ArrayCopy(tmp,aA,0,aS,128);
   ArraySort(tmp);
   double sum=0;
      for(int i=32;i<96;i++){
       sum+=tmp[i];
      }  
   return(sum/64+0.00000001);
}